%define ALD_Ver		2.0

Name:         procps

License:      GPL GPLv2
Summary:      proc file system utilities
Group:        System/Tools
Version:      3.3.17
Release:      0
URL: https://sourceforge.net/projects/procps-ng/

#Source: https://sourceforge.net/projects/procps-ng/files/Production/procps-ng-3.3.17.tar.xz

Source: %{name}-ng-%{version}.tar.xz

%define DestDir		/System/%{name}/%{version}
# -----------------------------------------------------

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}
%define _CROSS 0
%define MakeLocCross 0
%define target_ %{nil}
%else
# rpm --target=armv7hl -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 1
%define _host %{_arch}-%{_os}%{_gnu}
%define target_ %{_host}-
%endif

#------------------ CROSS DIR --------------------

%define _bindir /bin
%define _sbindir /sbin
%define _usrbindir	%{_prefix}/bin
%define _usrsbindir	%{_prefix}/sbin
%define docdir		%{_defaultdocdir}/%{name}

%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{have_auto_local}
%define __os_install_post %{nil}
%define CrossPath	%(%{auto_local} -GetCrossPath -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu})
%endif

# ------------------- description ------------------------------------
%description
proc file system utilities
#-------------------------------
%package devel
Summary:      Libraries for the C compiler
Group:        Development/Libraries
%description devel
These libraries are needed to compile C code.
# --------------------------------------
%package devel-man
Summary:      man3 for Libraries
Group:        Development/Libraries
%description devel-man
man3 for Libraries
#-------------------------------
%package free
Summary:      Basic system
Group:        System Environment/Base
%description free
Basic system
#-------------------------------
%package kill
Summary:      Basic system
Group:        System Environment/Base
%description kill
Basic system
#-------------------------------
%package pgrep-pkill
Summary:      Basic system
Group:        System Environment/Base
%description pgrep-pkill
Basic system
#-------------------------------
%package pidof
Summary:      Basic system
Group:        System Environment/Base
%description pidof
Basic system
#-------------------------------
%package pmap
Summary:      Basic system
Group:        System Environment/Base
%description pmap
Basic system
#-------------------------------
%package ps
Summary:      Basic system
Group:        System Environment/Base
%description ps
Basic system
#-------------------------------
%package pwdx
Summary:      Basic system
Group:        System Environment/Base
%description pwdx
Basic system
#-------------------------------
%package slabtop
Summary:      Basic system
Group:        System Environment/Base
%description slabtop
Basic system
#-------------------------------
%package sysctl
Summary:      Basic system
Group:        System Environment/Base
%description sysctl
Basic system
#-------------------------------
%package tload
Summary:      Basic system
Group:        System Environment/Base
%description tload
Basic system
#-------------------------------
%package top
Summary:      Basic system
Group:        System Environment/Base
%description top
Basic system
#-------------------------------
%package uptime
Summary:      Basic system
Group:        System Environment/Base
%description uptime
Basic system
#-------------------------------
%package vmstat
Summary:      Basic system
Group:        System Environment/Base
%description vmstat
Basic system
#-------------------------------
%package w
Summary:      Basic system
Group:        System Environment/Base
%description w
Basic system
#-------------------------------
%package watch
Summary:      Basic system
Group:        System Environment/Base
%description watch
Basic system

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{name}-%{version}

# disable pwait
sed -i s:"enable_pwait=yes":"enable_pwait=": configure

# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i586 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -Os -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables"

CFLAGS="$OPTFLAGS -ffunction-sections -fdata-sections -D_GNU_SOURCE"
LDFLAGS="-Wl,--gc-sections"

%configure \
	--disable-shared \
	--disable-silent-rules \
	--disable-rpath \
	--disable-nls \
	--disable-libselinux \
	--disable-numa \
	--disable-modern-top \
	&>FConfigure_log.txt

make &>FMake_log.txt

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_sbindir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt

rm $RPM_BUILD_ROOT%{_libdir}/*.la
rm -r $RPM_BUILD_ROOT%{_defaultdocdir}/procps-ng

cp -a AUTHORS Documentation/FAQ $RPM_BUILD_ROOT%{docdir}/
ln -s /usr/share/doc/gpl-2.0.txt $RPM_BUILD_ROOT%{docdir}/COPYING
ln -s /usr/share/doc/lgpl-2.0.txt $RPM_BUILD_ROOT%{docdir}/COPYING.LIB
(cd $RPM_BUILD_ROOT%{_bindir}; rm pkill; ln -s pgrep pkill;)

mv $RPM_BUILD_ROOT%{_bindir}/w $RPM_BUILD_ROOT%{_bindir}/w.procps
mv $RPM_BUILD_ROOT%{_mandir}/man1/w.1 $RPM_BUILD_ROOT%{_mandir}/man1/w.procps.1

mkdir -p $RPM_BUILD_ROOT%{_usrbindir}
for f in free pgrep pkill pmap pwdx slabtop tload top uptime vmstat w.procps; do
    mv $RPM_BUILD_ROOT{%_bindir,%_usrbindir}/$f
done
#mv $RPM_BUILD_ROOT{%_sbindir,/sbin}
rm -r $RPM_BUILD_ROOT%{_mandir}/man1/procps.1
rm -r $RPM_BUILD_ROOT%{_mandir}/de
rm -r $RPM_BUILD_ROOT%{_mandir}/fr
rm -r $RPM_BUILD_ROOT%{_mandir}/pl
rm -r $RPM_BUILD_ROOT%{_mandir}/pt_BR
rm -r $RPM_BUILD_ROOT%{_mandir}/sv
rm -r $RPM_BUILD_ROOT%{_mandir}/uk

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} -DelLocCrossDir=%{_bindir}
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean 

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-MakeLocCross=%{MakeLocCross} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# --------------------------------------------------------------------
%post w
if [ ! -e %{_usrbindir}/w ] ; then
  (cd %{_usrbindir} ; ln -s w.procps w)
  (cd %{_mandir}/man1 ; ln -s w.procps.1.gz w.1.gz)
fi

%preun w
if [ -L %{_usrbindir}/w ] && [ x"`readlink %{_usrbindir}/w`" = x"w.procps" ] ; then
  rm %{_usrbindir}/w
  rm %{_mandir}/man1/w.1.gz
fi

# ------------------- Files ------------------------------------------
%files
%{docdir}

%files devel
%{_includedir}
%{_libdir}/libprocps.a
%{_libdir}/pkgconfig/libprocps.pc

%files devel-man
%{_mandir}/man3

%files kill
%{_bindir}/kill
%{_mandir}/man1/kill.1.gz

%files pidof
%{_bindir}/pidof
%{_mandir}/man1/pidof.1.gz

%files ps
%{_bindir}/ps
%{_mandir}/man1/ps.1.gz

%files watch
%{_bindir}/watch
%{_mandir}/man1/watch.1.gz

%files sysctl
%{_sbindir}/sysctl
%{_mandir}/man5/sysctl.conf.5.gz
%{_mandir}/man8/sysctl.8.gz

%files free
%{_usrbindir}/free
%{_mandir}/man1/free.1.gz

%files pgrep-pkill
%{_usrbindir}/pgrep
%{_mandir}/man1/pgrep.1.gz
%{_usrbindir}/pkill
%{_mandir}/man1/pkill.1.gz

%files pmap
%{_usrbindir}/pmap
%{_mandir}/man1/pmap.1.gz

%files pwdx
%{_usrbindir}/pwdx
%{_mandir}/man1/pwdx.1.gz

%files slabtop
%{_usrbindir}/slabtop
%{_mandir}/man1/slabtop.1.gz

%files tload
%{_usrbindir}/tload
%{_mandir}/man1/tload.1.gz

%files top
%{_usrbindir}/top
%{_mandir}/man1/top.1.gz

%files uptime
%{_usrbindir}/uptime
%{_mandir}/man1/uptime.1.gz

%files vmstat
%{_usrbindir}/vmstat
%{_mandir}/man8/vmstat.8.gz

%files w
%{_usrbindir}/w.procps
%{_mandir}/man1/w.procps.1.gz
